-- 2009 Bridgeofstraws
-- This lua file is based off Rivet.ua
Vector={}

function Vector:init()
        self.pluginversion=1.0
        self.vectorname=""
        self.howtouse="This plugin saves the position, normalized direction, and the transformations"..
	              "\n Moray does to the object (scale,rotate,translate).  They are saved in the"..
	              "\n variables named \"[Vector Name]Position\", \"[Vector Name]Direction\","..
	              "\n and \"[Vector Name]Trans\"\n"
end

function Vector:destroy()
end

function Vector:load(stream)
        self.pluginversion=stream:readDouble()
        self.vectorname=stream:readString()
end

function Vector:save(stream)
        stream:writeDouble(self.pluginversion)
        stream:writeString(self.vectorname)   
end

function Vector:getProperties()
	return	"Vector",
		"73BE6164AAFD1CCF",
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"..
		"3333333333333333"
end

function Vector:getDialog(dialog)
        dialog:addSeparator("Vector")
        self.vectornameID=dialog:addTextEdit("Vector Name",self.vectorname)
        self.howtousebuttonID=dialog:addButton("How To Use This Plugin")
end

function Vector:valueChanged(id,value)
        if id==self.vectornameID then
                self.vectorname=value
                self:redraw()
                scene:invalidate()        
        elseif id==self.howtousebuttonID then
                messageBox("HowToUseThisPlugin", self.howtouse.."\nCreated by: Michael Strawbridge")
        end
end

function Vector:getInside(x,y,z)
	return nil
end

function Vector:toPOV(pov)
        pov:write("#include \"transforms.inc\"")
        pov:write("#declare "..self.vectorname.."Trans = transform{")
        pov:transforms(self.xforms)
        pov:write("};")
        pov:write("#declare "..self.vectorname.."Position = vtransform(<0,0,0>,"..self.vectorname.."Trans);")
        pov:write("#declare "..self.vectorname.."Direction = vtransform(<0,0,1>,"..self.vectorname.."Trans) - "..self.vectorname.."Position;")
        pov:write("#debug concat(\"\\n\",\""..self.vectorname.."Position:\",vstr(3, "..self.vectorname.."Position, \", \", 0,-1),\"\\n\")")
        pov:write("#debug concat(\"\\n\",\""..self.vectorname.."Direction:\",vstr(3, "..self.vectorname.."Direction, \", \", 0,-1),\"\\n\")")
        pov:write("box{-.001,.001 pigment {rgbt 1}") -- added so the code can be part of a CSG
        pov:transforms(self.xforms) -- added so the code can be part of a CSG
        pov:write("}") -- added so the code can be part of a CSG
end

function Vector:wireframe(wire)
        local	radius, height
        radius=.125
        height=1
        --the arrow
        wire:circleZ(0,0,height*27/32,radius/2,0,360)
        wire:circleZ(0,0,height*28/32,radius/3,0,360)
        wire:circleZ(0,0,height*29/32,radius/4,0,360)
        wire:circleZ(0,0,height*30/32,radius/6,0,360)
        wire:circleZ(0,0,height*31/32,radius/8,0,360)
        --the stick
        wire:line(0,0,height,0,0,0)
end

registerClass(Vector,"Vector")

